(* mem.v *)
(* A template for defining Memory Models *)

Require Import Equalities.
Require Import ZArith.

Require Import spec.
Require Export common.
Require Import sact.

Module Type Mem_T <: Typ.

(* A memory model is just any abstract type *)
Parameter t : Type.

(* that is required to support the following operations *)
Parameter getMemCheck : Z -> SCheck (State := t).
Parameter getMem : Z -> SGet (State := t) Z.
Parameter setMemCheck : Z -> SCheck (State := t).
Parameter setMem : Z -> Z -> SAct (State := t).

End Mem_T. 
