(* ALD : Memory with Allocation and AT disabled *)

Require Import DecidableType.
Require Import ZArith.
Require Import NArith.
Require Import Bool.
Require Import IfProp.

Require Import label.
Require Import spec.
Require Import scap.
Require Import zbool_assist.

Require Import Logic.FunctionalExtensionality.

Create HintDb Zbool_simpl discriminated.
Hint Rewrite Zeq_eq_bool using assumption : Zbool_simpl.
Hint Rewrite Zneq_eq_bool_false using assumption : Zbool_simpl.
Hint Rewrite Zeq_bool_refl : Zbool_simpl.


(* We would rather deal with functions, and not actions proper.
   for this we created a system that works in a functional way using the
   (bool, state) -> (bool, state) function type.
   the boolean indicates whether the state is valid, while the state is the actual state.
   when the boolean is false, the state indicates the best guess that we have.
   this is useful in creation of equalities *)
Require Export common.
Require Import sact.
Require Import actsmp.

Require Import c.
Require Import pe.

Module PE_Lib.

Import C_PE.

Definition tlb_reset_spec : Action State :=
SAct_Action (StackCheck (getArgsCheck 0))
	           (StackAct (pop +++ setRet 0%Z) +++ 
	             (MemAct (setTLB true))).

Definition pe_lib_spec : SpecHeap := fun l =>
  match l with
  | tlb_reset_label => Some tlb_reset_spec
  | _ => None
  end.

End PE_Lib.
